# :coffee: JAVA

+ [Java 反射与注解](notes/Java_反射与注解.md)
+ [Java 并发编程](notes/Java_并发编程.md)
+ [Java 设计模式](notes/Java_设计模式.md)
+ 深入理解 Java 虚拟机



## 💻 前端基础

- [JavaScript 基础](notes/JavaScript_基础.md)
- [ECMAScript 6.0 基础](notes/ES6_基础.md)



## 💾 数据库

### MySQL

+ [MySQL 核心概念](notes/MySQL_基础.md)
+ [MySQL 备份详解](notes/MySQL_备份.md)
+ [MySQL 二进制日志复制、GTID 复制与半同步复制](notes/MySQL_复制.md)
+ [MySQL 高可用架构之 PXC 集群](notes/MySQL_PXC集群.md)
+ [MyCat 读写分离与分库分表](notes/MySQL_Mycat中间件.md)
+ [MySQL 查询性能分析之 Explain](notes/MySQL_EXPLAIN.md)

### Redis

+ [Redis 基本数据类型和常用命令](notes/Redis_数据类型和常用命令.md)
+ [Redis AOF 和 RDB 持久化策略原理](notes/Redis_持久化.md)
+ [Redis 哨兵模式](notes/Redis_哨兵模式.md)
+ [Reids 集群模式](notes/Redis_集群模式.md)

### MongoDB

+ [MongoDB 基础](notes/MongoDB_基础.md)
+ [MongoDB 索引](notes/MongoDB_索引.md)
+ [MongoDB 聚合](notes/MongoDB_聚合.md)
+ [MongoDB 复制](notes/MongoDB_复制.md)
+ [MongoDB 分片](notes/MongoDB_分片.md)



## 📟 操作系统

+ [Linux 常用 Shell 命令](notes/Linux_常用Shell命令.md)
+ [Docker 基础](notes/Docker_基础.md)



##  :books: 常用技术栈

### Kafka

+ [Kafka 简介](https://github.com/heibaiying/BigData-Notes/blob/master/notes/Kafka简介.md)
+ [基于 Zookeeper 搭建 Kafka 高可用集群](https://github.com/heibaiying/BigData-Notes/blob/master/notes/installation/基于Zookeeper搭建Kafka高可用集群.md)
+ [Kafka 生产者详解](https://github.com/heibaiying/BigData-Notes/blob/master/notes/Kafka生产者详解.md)
+ [Kafka 消费者详解](https://github.com/heibaiying/BigData-Notes/blob/master/notes/Kafka消费者详解.md)
+ [深入理解 Kafka 副本机制](https://github.com/heibaiying/BigData-Notes/blob/master/notes/Kafka深入理解分区副本机制.md)

### RabbitMQ

+ [RabbitMQ 核心概念](notes/RabbitMQ_基础.md)
+ [RabbitMQ 客户端开发](notes/RabbitMQ_客户端开发.md)
+ [HAProxy + KeepAlived 搭建 RabbitMQ 高可用集群](notes/RabbitMQ_高可用集群架构.md)

### ZooKeeper 

+ [ZooKeeper 简介及核心概念](https://github.com/heibaiying/BigData-Notes/blob/master/notes/Zookeeper简介及核心概念.md)
+ [ZooKeeper 单机环境和集群环境搭建](https://github.com/heibaiying/BigData-Notes/blob/master/notes/installation/Zookeeper单机环境和集群环境搭建.md) 
+ [ZooKeeper 常用 Shell 命令](https://github.com/heibaiying/BigData-Notes/blob/master/notes/Zookeeper常用Shell命令.md)
+ [ZooKeeper Java 客户端](https://github.com/heibaiying/BigData-Notes/blob/master/notes/Zookeeper_Java客户端Curator.md)
+ [ZooKeeper  ACL 权限控制](https://github.com/heibaiying/BigData-Notes/blob/master/notes/Zookeeper_ACL权限控制.md)

### Nginx

- [Nginx 基础之静态网站部署，负载均衡，动静分离](notes/Nginx_基础.md)



##  :hammer: 软件安装

+ [Redis 单机环境安装](installation\Redis单机环境搭建.md)
+ [RabbitMQ 单机环境安装](installation\RabbitMQ单机环境搭建.md)
+ [Nginx 单机环境安装](installation\Nginx编译方式安装.md)
+ [MySQL 单机环境安装](installation\MySQL单机环境搭建.md)
+ [MongoDB 单机环境安装](installation\MongoDB单机环境搭建.md)
+ [ElasticSearch + Kibana 单机环境安装](installation\ElasticSearch+Kibana单机环境搭建.md)
